package demo;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import cbr.Caze;
import model1.Model1SimilarityFunction;

public class CazePanel extends JPanel {

	private static final long serialVersionUID = 1L;

	private JLabel lblTimestamp = new JLabel("<html>Timestamp:<br>0000-00-00T00:00:00</html>");

	private JLabel lblAvsjoen = new JLabel("Avsjen");
	private JLabel lblFokstugu = new JLabel("Fokstugu");
	private JLabel lblHjerkinn = new JLabel("Hjerkinn");

	private JLabel lblWindSpeed = new JLabel("Wind Speed");
	private JLabel lblWindDirection = new JLabel("Wind Direction");
	private JLabel lblFriction = new JLabel("Friction");
	private JLabel lblTemperature = new JLabel("Temperature");

	private JLabel lblWindSpeedAvsjoen = new JLabel();
	private JLabel lblWindSpeedFokstugu = new JLabel();
	private JLabel lblWindSpeedHjerkinn = new JLabel();

	private JLabel lblWindDirectionAvsjoen = new JLabel();
	private JLabel lblWindDirectionFokstugu = new JLabel();
	private JLabel lblWindDirectionHjerkinn = new JLabel();

	private JLabel lblFrictionAvsjoen = new JLabel();
	private JLabel lblFrictionFokstugu = new JLabel();

	private JLabel lblTemperatureAvsjoen = new JLabel();
	private JLabel lblTemperatureFokstugu = new JLabel();
	private JLabel lblTemperatureHjerkinn = new JLabel();

	private JLabel lblDecision = new JLabel("<html>Decision:<br>-</html>");

	public CazePanel() {
		super(new GridBagLayout());
		setBorder(BorderFactory.createLineBorder(Color.BLACK, 2, true));
		GridBagConstraints c = new GridBagConstraints();
		c.insets.left = 10;
		c.insets.right = 10;
		c.insets.bottom = 10;
		c.gridx = 0;
		c.gridy = 0;
		add(lblTimestamp, c);
		c.gridx = 2;
		c.gridy = 0;
		add(lblDecision, c);
		c.insets.bottom = 0;
		c.gridx = 1;
		c.gridy = 1;
		add(lblAvsjoen, c);
		c.gridx = 2;
		c.gridy = 1;
		add(lblFokstugu, c);
		c.gridx = 3;
		c.gridy = 1;
		add(lblHjerkinn, c);
		c.gridx = 0;
		c.gridy = 2;
		add(lblWindSpeed, c);
		c.gridx = 0;
		c.gridy = 3;
		add(lblWindDirection, c);
		c.gridx = 0;
		c.gridy = 4;
		add(lblFriction, c);
		c.gridx = 0;
		c.gridy = 5;
		add(lblTemperature, c);
		c.gridx = 1;
		c.gridy = 2;
		add(lblWindSpeedAvsjoen, c);
		c.gridx = 2;
		c.gridy = 2;
		add(lblWindSpeedFokstugu, c);
		c.gridx = 3;
		c.gridy = 2;
		add(lblWindSpeedHjerkinn, c);
		c.gridx = 1;
		c.gridy = 3;
		add(lblWindDirectionAvsjoen, c);
		c.gridx = 2;
		c.gridy = 3;
		add(lblWindDirectionFokstugu, c);
		c.gridx = 3;
		c.gridy = 3;
		add(lblWindDirectionHjerkinn, c);
		c.gridx = 1;
		c.gridy = 4;
		add(lblFrictionAvsjoen, c);
		c.gridx = 2;
		c.gridy = 4;
		add(lblFrictionFokstugu, c);
		c.gridx = 1;
		c.gridy = 5;
		add(lblTemperatureAvsjoen, c);
		c.gridx = 2;
		c.gridy = 5;
		add(lblTemperatureFokstugu, c);
		c.gridx = 3;
		c.gridy = 5;
		add(lblTemperatureHjerkinn, c);
	}

	public void setCaze(Caze caze) {
		lblTimestamp.setText("<html>Timestamp:<br>" + caze.getTimestamp().toString() + "</html>");
		lblDecision.setText("<html>Decision:<br>" + caze.getDecision().toString() + "</html>");
		lblWindSpeedFokstugu.setText(caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[0]) == null ? "-"
				: caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[0]).toString());
		lblWindDirectionFokstugu.setText(caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[1]) == null ? "-"
				: caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[1]).toString());
		lblFrictionFokstugu.setText(caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[2]) == null ? "-"
				: caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[2]).toString());
		lblTemperatureFokstugu.setText(caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[3]) == null ? "-"
				: caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[3]).toString());
		lblWindSpeedAvsjoen.setText(caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[4]) == null ? "-"
				: caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[4]).toString());
		lblWindDirectionAvsjoen.setText(caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[5]) == null ? "-"
				: caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[5]).toString());
		lblFrictionAvsjoen.setText(caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[6]) == null ? "-"
				: caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[6]).toString());
		lblTemperatureAvsjoen.setText(caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[7]) == null ? "-"
				: caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[7]).toString());
		lblWindSpeedHjerkinn.setText(caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[8]) == null ? "-"
				: caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[8]).toString());
		lblWindDirectionHjerkinn.setText(caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[9]) == null ? "-"
				: caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[9]).toString());
		lblTemperatureHjerkinn.setText(caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[10]) == null ? "-"
				: caze.getAttributeValue(Model1SimilarityFunction.ATTRIBUTES[10]).toString());
	}
}
