package demo;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.text.ParseException;
import java.util.Set;

import javax.swing.JButton;
import javax.swing.JPanel;

import cbr.CBR;
import cbr.Caze;
import cbr.CazeFileReader;
import model1.Model1SimilarityFunction;

public class DemoPanel extends JPanel {

	private static final long serialVersionUID = 1L;

	private CBR cbr = new CBR(new Model1SimilarityFunction());

	private QueryPanel queryPanel = new QueryPanel();
	private JButton btnStart = new JButton("Query -- > Most Similar Case");
	private CazePanel cazePanel = new CazePanel();

	public DemoPanel() throws IOException, ParseException {
		Set<Caze> cazeBase = CazeFileReader.readFile(new File("trainingset.csv"));
		cbr.setCazeBase(cazeBase);
		add(queryPanel);
		add(btnStart);
		btnStart.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				start();
			}
		});
		add(cazePanel);
	}

	private void start() {
		Caze query = queryPanel.getQuery();
		Caze mostSimilarCaze = cbr.mostSimilarCaze(query);
		cazePanel.setCaze(mostSimilarCaze);
	}
}
