package ea_gui;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

public class AdultSelectorPanel extends JPanel {

	private static final long serialVersionUID = 1L;

	public static final int REPLACEMENT = 0;
	public static final int MIXING = 1;

	private int selector = REPLACEMENT;

	private JRadioButton btnReplacement = new JRadioButton("Replacement");
	private JRadioButton btnMixing = new JRadioButton("Mixing");
	private JLabel lblAdults = new JLabel("#Adults:");
	private JTextField txtAdults = new JTextField(5);

	public AdultSelectorPanel() {
		super(new GridBagLayout());
		setBorder(BorderFactory.createLineBorder(Color.BLACK, 2, true));
		GridBagConstraints c = new GridBagConstraints();
		c.insets.right = 10;
		c.gridx = 0;
		add(btnReplacement, c);
		c.gridx = 1;
		add(btnMixing, c);
		c.insets.right = 5;
		c.gridx = 2;
		add(lblAdults, c);
		c.gridx = 3;
		add(txtAdults, c);
		btnReplacement.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				selector = REPLACEMENT;
				updateView();
			}
		});
		btnMixing.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				selector = MIXING;
				updateView();
			}
		});
		updateView();
	}

	private void updateView() {
		btnReplacement.setSelected(false);
		btnMixing.setSelected(false);
		switch (selector) {
		case REPLACEMENT:
			btnReplacement.setSelected(true);
			break;
		case MIXING:
			btnMixing.setSelected(true);
			break;
		}
	}

	public int getSelector() {
		return selector;
	}

	public int getAdults() {
		return Integer.parseInt(txtAdults.getText());
	}
}
